diff -r fb51f5b4aa4c trytond/tests/test_fields.py
--- a/trytond/tests/test_fields.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/tests/test_fields.py	Mon Sep 24 20:36:36 2012 +0200
@@ -1846,270 +1750,258 @@
             yesterday = today - datetime.timedelta(1)
             default_datetime = datetime.datetime(2000, 1, 1, 12, 0, 0)
 
-            datetime1_id = self.datetime.create({
-                'datetime': today,
-                })
-            self.assert_(datetime1_id)
-
-            datetime1 = self.datetime.read(datetime1_id, ['datetime'])
-            self.assert_(datetime1['datetime'] == today)
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '=', today),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '=', tomorrow),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '=', False),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '!=', today),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '!=', tomorrow),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '!=', False),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', 'in', [today]),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', 'in', [tomorrow]),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', 'in', [False]),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', 'in', []),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', 'not in', [today]),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', 'not in', [tomorrow]),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', 'not in', [False]),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', 'not in', []),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '<', tomorrow),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '<', yesterday),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '<', today),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '<=', today),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '<=', yesterday),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '<=', tomorrow),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '>', tomorrow),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '>', yesterday),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '>', today),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '>=', tomorrow),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '>=', yesterday),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '>=', today),
-                ])
-            self.assert_(datetime_ids == [datetime1_id])
-
-            datetime2_id = self.datetime.create({
-                'datetime': yesterday,
-                })
-            self.assert_(datetime2_id)
-
-            datetime2 = self.datetime.read(datetime2_id, ['datetime'])
-            self.assert_(datetime2['datetime'] == yesterday)
-
-            datetime_ids = self.datetime.search([
-                ('datetime', '=', yesterday),
-                ])
-            self.assert_(datetime_ids == [datetime2_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', 'in', [yesterday, today]),
-                ])
-            self.assert_(datetime_ids == [datetime1_id, datetime2_id])
-
-            datetime_ids = self.datetime.search([
-                ('datetime', 'not in', [yesterday, today]),
-                ])
-            self.assert_(datetime_ids == [])
-
-            datetime3_id = self.datetime.create({})
-            self.assert_(datetime3_id)
-
-            datetime3 = self.datetime.read(datetime3_id, ['datetime'])
-            self.assert_(datetime3['datetime'] == None)
-
-            datetime4_id = self.datetime_default.create({})
-            self.assert_(datetime4_id)
-
-            datetime4 = self.datetime_default.read(datetime4_id, ['datetime'])
-            self.assert_(datetime4['datetime'] == default_datetime)
-
-            self.datetime.write(datetime1_id, {
-                'datetime': yesterday,
-                })
-            datetime1 = self.datetime.read(datetime1_id, ['datetime'])
-            self.assert_(datetime1['datetime'] == yesterday)
-
-            self.datetime.write(datetime2_id, {
-                'datetime': today,
-                })
-            datetime2 = self.datetime.read(datetime2_id, ['datetime'])
-            self.assert_(datetime2['datetime'] == today)
-
-            self.failUnlessRaises(Exception, self.datetime.create, {
-                'datetime': 'test',
-                })
-
-            self.failUnlessRaises(Exception, self.datetime.write, datetime1_id,
-                    {
-                        'datetime': 'test',
+            datetime1 = self.datetime.create({
+                    'datetime': today,
                     })
-
-            self.failUnlessRaises(Exception, self.datetime.create, {
-                'datetime': 1,
-                })
-
-            self.failUnlessRaises(Exception, self.datetime.write, datetime1_id,
-                    {
-                        'datetime': 1,
+            self.assert_(datetime1)
+            self.assertEqual(datetime1.datetime, today)
+
+            datetimes = self.datetime.search([
+                    ('datetime', '=', today),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '=', tomorrow),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '=', None),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '!=', today),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '!=', tomorrow),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '!=', None),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', 'in', [today]),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', 'in', [tomorrow]),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', 'in', [None]),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', 'in', []),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', 'not in', [today]),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', 'not in', [tomorrow]),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', 'not in', [None]),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', 'not in', []),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '<', tomorrow),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '<', yesterday),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '<', today),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '<=', today),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '<=', yesterday),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '<=', tomorrow),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '>', tomorrow),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '>', yesterday),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '>', today),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '>=', tomorrow),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '>=', yesterday),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetimes = self.datetime.search([
+                    ('datetime', '>=', today),
+                    ])
+            self.assertEqual(datetimes, [datetime1])
+
+            datetime2 = self.datetime.create({
+                    'datetime': yesterday,
                     })
-
-            self.failUnlessRaises(Exception, self.datetime.create, {
-                'datetime': datetime.date.today(),
-                })
-
-            self.failUnlessRaises(Exception, self.datetime.write, datetime1_id,
-                    {
-                        'datetime': datetime.date.today(),
+            self.assert_(datetime2)
+            self.assertEqual(datetime2.datetime, yesterday)
+
+            datetimes = self.datetime.search([
+                    ('datetime', '=', yesterday),
+                    ])
+            self.assertEqual(datetimes, [datetime2])
+
+            datetimes = self.datetime.search([
+                    ('datetime', 'in', [yesterday, today]),
+                    ])
+            self.assertEqual(datetimes, [datetime1, datetime2])
+
+            datetimes = self.datetime.search([
+                    ('datetime', 'not in', [yesterday, today]),
+                    ])
+            self.assertEqual(datetimes, [])
+
+            datetime3 = self.datetime.create({})
+            self.assert_(datetime3)
+            self.assertEqual(datetime3.datetime, None)
+
+            datetime4 = self.datetime_default.create({})
+            self.assert_(datetime4)
+            self.assertEqual(datetime4.datetime, default_datetime)
+
+            self.datetime.write([datetime1], {
+                    'datetime': yesterday,
                     })
-
-            self.failUnlessRaises(Exception, self.datetime.create, {
-                'datetime': '2009-13-01 12:30:00',
-                })
-
-            self.failUnlessRaises(Exception, self.datetime.write, datetime1_id,
-                    {
-                        'datetime': '2009-02-29 12:30:00',
+            self.assertEqual(datetime1.datetime, yesterday)
+
+            self.datetime.write([datetime2], {
+                    'datetime': today,
                     })
-
-            self.failUnlessRaises(Exception, self.datetime.write, datetime1_id,
-                    {
-                        'datetime': '2009-01-01 25:00:00',
+            self.assertEqual(datetime2.datetime, today)
+
+            self.assertRaises(Exception, self.datetime.create, {
+                    'datetime': 'test',
                     })
 
-            datetime5_id = self.datetime.create({
-                'datetime': '2009-01-01 12:00:00',
-                })
-            self.assert_(datetime5_id)
-            datetime5 = self.datetime.read(datetime5_id, ['datetime'])
-            self.assertEqual(datetime5['datetime'],
+            self.assertRaises(Exception, self.datetime.write, [datetime1],
+                {
+                    'datetime': 'test',
+                    })
+
+            self.assertRaises(Exception, self.datetime.create, {
+                    'datetime': 1,
+                    })
+
+            self.assertRaises(Exception, self.datetime.write, [datetime1],
+                {
+                    'datetime': 1,
+                    })
+
+            self.assertRaises(Exception, self.datetime.create, {
+                    'datetime': datetime.date.today(),
+                    })
+
+            self.assertRaises(Exception, self.datetime.write, [datetime1],
+                {
+                    'datetime': datetime.date.today(),
+                    })
+
+            self.assertRaises(Exception, self.datetime.create, {
+                    'datetime': '2009-13-01 12:30:00',
+                    })
+
+            self.assertRaises(Exception, self.datetime.write, [datetime1],
+                {
+                    'datetime': '2009-02-29 12:30:00',
+                    })
+
+            self.assertRaises(Exception, self.datetime.write, [datetime1],
+                {
+                    'datetime': '2009-01-01 25:00:00',
+                    })
+
+            datetime5 = self.datetime.create({
+                    'datetime': '2009-01-01 12:00:00',
+                    })
+            self.assert_(datetime5)
+            self.assertEqual(datetime5.datetime,
                 datetime.datetime(2009, 1, 1, 12, 0, 0))
 
-            self.failUnlessRaises(Exception, self.datetime_required.create, {})
+            self.assertRaises(Exception, self.datetime_required.create, {})
             transaction.cursor.rollback()
 
-            datetime6_id = self.datetime_required.create({
-                'datetime': today,
-                })
-            self.assert_(datetime6_id)
-
-            datetime7_id = self.datetime.create({
-                'datetime': None,
-                })
-            self.assert_(datetime7_id)
-
-            datetime8_id = self.datetime.create({
-                'datetime': None,
-                })
-            self.assert_(datetime8_id)
-
-            datetime9_id = self.datetime.create({
-                'datetime': today.replace(microsecond=1),
-                })
-            self.assert_(datetime9_id)
-            datetime9 = self.datetime.read(datetime9_id, ['datetime'])
-            self.assert_(datetime9['datetime'] == today)
+            datetime6 = self.datetime_required.create({
+                    'datetime': today,
+                    })
+            self.assert_(datetime6)
+
+            datetime7 = self.datetime.create({
+                    'datetime': None,
+                    })
+            self.assert_(datetime7)
+
+            datetime8 = self.datetime.create({
+                    'datetime': None,
+                    })
+            self.assert_(datetime8)
+
+            datetime9 = self.datetime.create({
+                    'datetime': today.replace(microsecond=1),
+                    })
+            self.assert_(datetime9)
+            self.assertEqual(datetime9.datetime, today)
 
             # Test format
             self.assert_(self.datetime_format.create({
                         'datetime': datetime.datetime(2009, 1, 1, 12, 30),
                         }))
-            self.failUnlessRaises(Exception, self.datetime_format.create, {
+            self.assertRaises(Exception, self.datetime_format.create, {
                     'datetime': datetime.datetime(2009, 1, 1, 12, 30, 25),
                     })
 
